<script setup lang="ts">
import { ref, nextTick, onMounted, computed } from 'vue'
import type { VForm } from 'vuetify/components'

// store
import { useMaterialStore } from '@/stores/material'
import { useStockStore } from '@/stores/stock'
import { useStockDetailStore } from '@/stores/stockDetail'
import { useUserStore } from '@/stores/user'

//type
import type { Stock } from '@/types/Stock'
import type { Material } from '@/types/Material'
import type { StockBill } from '@/types/StockBill'
import type { StockDetail } from '@/types/StockDetail'

const stockStore = useStockStore()
const materialStore = useMaterialStore()
const userStore = useUserStore()
const stockDetailStore = useStockDetailStore()
const form = ref(false)
const refFormAddmat = ref<VForm | null>(null)
const refFormSave = ref<VForm | null>(null)
const loading = ref(false)
const divReceiptItems = ref<HTMLElement | null>(null)

function onSubmit() { }
onMounted(() => {
  materialStore.getMaterials()
  materialStore.getMaterialsInNewAtt()
})
//save จากปุ่ม add new material
async function save() {
  const { valid } = await refFormSave.value!.validate()
  console.log(valid)
  if (!valid) return
  const existingMaterial = materialStore.addsomeMaterial.find(
    (mat) => mat.name.trim().toLowerCase() === materialStore.editMaterial.name.trim().toLowerCase()
  )

  if (existingMaterial) {
    // หากมีชื่อซ้ำใน addsomeMaterial ให้ทำการอัพเดตค่า
    Object.assign(existingMaterial, materialStore.editMaterial)
  } else {
    // ถ้าไม่ซ้ำให้เพิ่มเข้าไปใน addsomeMaterial
    materialStore.addsomeMaterial.push(materialStore.editMaterial)
  }
  materialStore.editMaterial = Object.assign({}, materialStore.initMaterial)
  materialStore.dialog = false
}
//save จาก materials ที่มีอยู่
async function addMat() {
  if (materialStore.editMaterial.name === '') return
  materialStore.editMaterial.amount = materialStore.amount
  const existingMaterial = materialStore.addsomeMaterial.find(
    (mat) => mat.name.trim().toLowerCase() === materialStore.editMaterial.name.trim().toLowerCase()
  )

  if (existingMaterial) {
    // หากมีชื่อซ้ำใน addsomeMaterial ให้ทำการอัพเดตค่า
    Object.assign(existingMaterial, materialStore.editMaterial)
  } else {
    // ถ้าไม่ซ้ำให้เพิ่มเข้าไปใน addsomeMaterial
    materialStore.addsomeMaterial.push(materialStore.editMaterial)
  }
  materialStore.editMaterial = Object.assign({}, materialStore.initMaterial)
}

//อย่าลืมไปเปิด Stock service ด้วย

const headersStockItem = [
  {
    title: 'ชื่อ',
    key: 'name',
    value: 'name'
  },
  {
    title: 'จำนวนที่มี',
    key: 'QOH',
    value: 'QOH'
  },
  {
    title: 'ลบวัตถุดิบ',
    key: 'actions'
  }
]
async function saveStock() {
  for (const material of materialStore.addsomeMaterial) {
    const existingMaterial = materialStore.materials.find(
      (mat) => mat.name.trim().toLowerCase() === material.name.trim().toLowerCase()
    )
    if (existingMaterial) {
      // Update existing material in materials array
      Object.assign(existingMaterial, material)
    } else {
      // Add new material from addsomeMaterial to materials array
      materialStore.materials.push(material)
    }
  }
  console.log('materials: ', materialStore.materials)
  for (const mat of materialStore.materials) {
    console.log('mat: ', mat)
    materialStore.saveMaterial(mat)
  }
  materialStore.getMaterials()
  materialStore.getMaterialsInNewAtt()

  const stock = ref<Stock>(stockStore.editedStock)
  //tran material to stockdetail
  const newMaterials: Material[] = materialStore.materials

  const stockDetails: StockDetail[] = []

  for (const mat of newMaterials) {
    const newStockDetail: StockDetail = {
      id: -1,
      QOH: mat.amount,
      materialId: mat.id,
      balance: mat.amount - mat.minimum,
      StockId: -1
    }

    stockDetails.push(newStockDetail)
  }

  console.log('newStockdetails', stockDetails)
  stock.value = {
    id: -1,
    date: stockStore.formatDate(new Date()),
    stockDetails: stockDetails,
    branchID: userStore.currentUser ? userStore.currentUser.branch.id : 2,
    userID: userStore.currentUser ? userStore.currentUser.id : 2
  }
  stockStore.saveStock(stock.value)
  console.log('stock while saving: ', stock.value)
  stockStore.closeDialog()
}

function deleteItemInSome(item: Material) {
  const existingMaterial = materialStore.addsomeMaterial.find(
    (mat) => mat.name.trim().toLowerCase() === item.name.trim().toLowerCase()
  )

  if (existingMaterial) {
    materialStore.addsomeMaterial = materialStore.addsomeMaterial.filter(
      (mat) => mat.name !== existingMaterial.name
    )
  }
}
</script>

<template>
  <v-dialog v-model="stockStore.addSomeDialog">
    <v-sheet border title="Addsome">
      <div class="d-flex align-center justify-end" style="padding: 5px"></div>
      <v-divider class="border-opacity-50"></v-divider>
      <div style="padding: 0px">
        <div class="align-center">
          <h2 class="text-h4 font-weight-black">Check Stock</h2>
          <p>การเช็คจำนวนวัตถุดิบที่เหลืออยู่ในคลัง</p>
        </div>
        <v-divider class="border-opacity-50"></v-divider>
      </div>
      <!-- addItem to ItemDetail -->
      <div style="padding-top: 5px; height: 100 px" class="d-flex justify-start">
        <v-row class="d-flex justify-start">
          <v-col cols="12" sm="6" md="4">
            <v-select style="padding-top: 12px" :item-title="(item) => item.name" :item-value="(item) => item"
              :items="materialStore.materials || []" :rules="[(v) => !!v || 'Item is required']"
              v-model="materialStore.editMaterial" label="Item" required></v-select>
          </v-col>

          <v-col cols="12" sm="6" md="4">
            <v-text-field style="padding-top: 12px" v-model.number="materialStore.amount"
              :rules="[(v) => !!v || 'Field is required']" class="mb-2" clearable label="จำนวน">
            </v-text-field>
          </v-col>
          <v-col cols="12" sm="6" md="2" style="padding-top: 20px">
            <v-btn color="blue-lighten-1" icon="mdi-language-markdown" size="small" @click="addMat()">SAVE</v-btn>
          </v-col>
          <v-col>
            <v-btn color="blue-lighten-1" size="small" @click="materialStore.dialog = true">
              ADD NEW MATERIAL</v-btn>
          </v-col>
          <v-col cols="12" sm="6" md="2">
            <!-- dialog add new material -->
            <v-dialog persistent width="500" v-model="materialStore.dialog">
              <v-card>
                <v-card-title>
                  <span class="text-h5">New Material</span>
                </v-card-title>
                <v-card-text>
                  <v-form ref="refFormSave" v-model="form" @submit.prevent="onSubmit">
                    <v-container>
                      <v-row>
                        <v-col cols="12" sm="12" md="4">
                          <v-text-field v-model="materialStore.editMaterial.name" :readonly="loading"
                            :rules="[(v) => !!v || 'Field is required']" class="mb-2" clearable
                            label="ชื่อวัตถุดิบ"></v-text-field>
                        </v-col>
                        <v-col cols="12" sm="12" md="4">
                          <v-text-field v-model.number="materialStore.editMaterial.minimum" :readonly="loading"
                            :rules="[(v) => !!v || 'Field is required']" class="mb-2" clearable
                            label="จำนวนขั้นต่ำ"></v-text-field>
                        </v-col>
                        <v-col cols="12" sm="12" md="4">
                          <v-text-field v-model.number="materialStore.editMaterial.amount" :readonly="loading"
                            :rules="[(v) => !!v || 'Field is required']" class="mb-2" clearable
                            label="จำนวนที่มีอยู่"></v-text-field>
                        </v-col>
                        <v-col cols="12" sm="12" md="4">
                          <v-text-field v-model="materialStore.editMaterial.type" :readonly="loading"
                            :rules="[(v) => !!v || 'Field is required']" class="mb-2" clearable label="หน่วยเรียก"
                            single-line></v-text-field>
                        </v-col>
                      </v-row>
                    </v-container>
                  </v-form>
                  <small>*indicates required field</small>
                </v-card-text>
                <v-card-actions>
                  <v-spacer></v-spacer>
                  <v-btn color="red-accent-3" variant="outlined" @click="materialStore.closeDialog()">
                    Close
                  </v-btn>
                  <!-- dialog -->
                  <v-btn color="blue-darken-1" variant="outlined" @click="save()"> Save </v-btn>
                </v-card-actions>
              </v-card>
            </v-dialog>
          </v-col>
        </v-row>
      </div>

      <!-- table show material -->
      <v-divider class="border-opacity-50"></v-divider>
      <v-data-table :headers="headersStockItem" :items="materialStore.addsomeMaterial" height="300" fixed-header
        hide-default-footer disable-pagination class="flex-table" overflow-y="hidden">
        <template v-slot:item="{ item }">
          <tr>
            <td>{{ item.name }}</td>
            <td>
              <v-text-field class="d-flex align-center" style="padding: 0px" variant="outlined" rounded="2"
                :rules="[(v) => !!v || 'Field is required']" background-color="primary" v-model.number="item.amount"
                clearable></v-text-field>
            </td>
            <td>
              <v-icon icon="mdi-delete-circle" size="large" color="red" @click="deleteItemInSome(item)"></v-icon>
              <!-- @click="stockStore.deleteItemSome(item)" -->
            </td>
          </tr>
        </template>
      </v-data-table>
      <div class="d-flex align-center justify-end">
        <v-btn @click="stockStore.closeDialog()" color="red">Close</v-btn>
        <!-- save ใหญ่ -->
        <v-btn @click="saveStock()" color="primary">Save</v-btn>
      </div>
    </v-sheet>
  </v-dialog>
</template>
